﻿
class Serializer implements Serializable {
  private var serializationProps:Array;
  private var serializationObj:Serializable;
  private var recordSeparator:String;

  public function Serializer () {
    setSerializationObj(this);
  }

  public function setSerializationProps (props:Array):Void {
    serializationProps = props;
  }

  public function setSerializationObj (obj:Serializable):Void {
    serializationObj = obj;
  }
  
  public function setRecordSeparator (rs:String):Void {
    recordSeparator = rs;
  }

  public function serialize ():String {
    var s:String = "";
    for (var i:Number = serializationProps.length; --i >= 0; ) {
      s += serializationProps[i] + "=" + String(serializationObj[serializationProps[i]]);
      if (i > 0) {
        s += recordSeparator;
      }
    }
    return s;
  }
}